package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmKeyPolluters;
import com.zksy.system.basicData.service.CrmKeyPollutersService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 环保监管-重点排污Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmKeyPolluters")
@Api(tags = "环保监管-重点排污", description = "环保监管-重点排污desc")
public class CrmKeyPollutersController extends BaseController{

    @Autowired
    private CrmKeyPollutersService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "环保监管-重点排污搜索getById")
    public CrmKeyPolluters getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "环保监管-重点排污分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "环保监管-重点排污查询所有")
    public List<CrmKeyPolluters> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增环保监管-重点排污
     */
    @PostMapping("/save")
    @ApiOperation(value = "环保监管-重点排污新增")
    @Log(title = "新增环保监管-重点排污", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmKeyPolluters crmKeyPolluters) {
        return service.save(crmKeyPolluters);
    }

    /**
     * 修改环保监管-重点排污
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "环保监管-重点排污修改")
    @Log(title = "修改环保监管-重点排污", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmKeyPolluters crmKeyPolluters) {
        return service.updateById(crmKeyPolluters);
    }

    /**
     * 导入环保监管-重点排污
     */
    @ApiOperation("环保监管-重点排污导入")
    @Log(title = "环保监管-重点排污", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmKeyPolluters> crmKeyPollutersAll = service.list();
            List<CrmKeyPolluters> list = ExcelUtils.readMultipartFile(file, CrmKeyPolluters.class,CrmKeyPolluters.class.getDeclaredFields().length - 2);
            if(crmKeyPollutersAll != null && crmKeyPollutersAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("环保监管-重点排污导出")
    @Log(title = "环保监管-重点排污", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmKeyPolluters> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"环保监管-重点排污",wrapperList,CrmKeyPolluters.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "环保监管-重点排污", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除环保监管-重点排污", notes = "删除环保监管-重点排污")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"环保监管-重点排污模板");
    }
}

